Which .Net Framework version can I use on Unity?

As title, many thank!

Mostly included features are from 3.5(pretty much all) with a little love from 4, you can check available features on unity’s mono compatibility page for specific namespaces and classes.

Unity 4.x uses Mono 2.6. You can see the Mono compatibility features at Unity Script Reference – Mono Compatibility